/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_NIASSNUTRI                                                      */
/* Tabela : NIASSNUTRI                                                              	*/
/*                                                                            */
/* Criao:                                                                   */
/* 28/10/2004 - Rafael dos Santos Lopes                           			   */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_NIASSNUTRI
BEFORE INSERT OR UPDATE OR DELETE
ON NIASSNUTRI FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUNINU := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.NMNIASNUTR,0) <> NVL(:NEW.NMNIASNUTR,0)) THEN
         :NEW.DTULTATUNINU := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('NIASSNUTRI', '', 'CDNIASNUTR='||:OLD.CDNIASNUTR||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE NIASSNUTRI MODIFY DTULTATUNINU DEFAULT SYSDATE
/

