 /* Sistemas Integrados TEKNISA
  Controle de Produo

 Nome: Rotina de apropriao dos Custos da OP

Criao:
17/10/02 - Ftima

@C:\Win_V?\Sql\End_Conv\Oracle\3900_CDPSTP_CALCULA_CUSTO_OP.sql
*/

IF EXISTS(SELECT name FROM sysobjects
          WHERE name = 'CALCULA_CUSTO_OP' AND type = 'P')
   DROP PROCEDURE CALCULA_CUSTO_OP
   GO

CREATE PROCEDURE CALCULA_CUSTO_OP
   @P_CDFILIAL       VARCHAR(4),
   @P_NRORDPROD      VARCHAR(10),
   @P_NRSUBORDPROD   VARCHAR(1),
   @P_CDPRODUTO      VARCHAR(10),
   @P_NRLOTEESTQ     VARCHAR(20),
   @P_NRSUBLOTE      VARCHAR(4)
AS
   DECLARE @V_SEQUCUSTO      VARCHAR(10);
   DECLARE @V_TIPOCUSTO      VARCHAR(2);
   DECLARE @V_NMTPCUSTO      VARCHAR(60);
   DECLARE @V_CDCUSTOINDI    VARCHAR(3);
   DECLARE @V_CDETAPAPROD    VARCHAR(10);
   DECLARE @V_VRFATOCONVES   DOUBLE PRECISION;
   DECLARE @V_QTPERDAOP      DOUBLE PRECISION;
   DECLARE @V_IDTPCALCCUSPROD VARCHAR(1);

   DECLARE @C_SUBPROD_NRLOTEESTQ     VARCHAR(20);
   DECLARE @C_SUBPROD_NRSUBLOTE      VARCHAR(4);

   DECLARE @C_CUSTCALC_CDETAPAPROD   VARCHAR(10);
   DECLARE @C_CUSTCALC_NRLOTEESTQ    VARCHAR(20);
   DECLARE @C_CUSTCALC_NRSUBLOTE     VARCHAR(4);
   DECLARE @C_CUSTCALC_IDORIGAUDIT   VARCHAR(3);
   DECLARE @C_CUSTCALC_NRAUDITORIA   VARCHAR(10);

   DECLARE @C_INSPECAO_IDORIGINSPEC  VARCHAR(3);
   DECLARE @C_INSPECAO_CDINSPECAO    VARCHAR(10);
   DECLARE @C_INSPECAO_NMINSPECAO    VARCHAR(200);
   DECLARE @C_INSPECAO_VRCUSTOINSP   DOUBLE PRECISION;
   DECLARE @C_INSPECAO_NRAUDITORIA   VARCHAR(10);
   DECLARE @C_INSPECAO_NRINSPECAUDI  VARCHAR(3);
   DECLARE @C_INSPECAO_IDCOMPOECUSTO VARCHAR(1);
   DECLARE @C_INSPECAO_VRCUSTOAMOSTRA  DOUBLE PRECISION;
   DECLARE @C_INSPECAO_VRCUSTORECURSO  DOUBLE PRECISION;
   DECLARE @C_INSPECAO_VRTOTALANA      DOUBLE PRECISION;

   DECLARE @C_RECURSO_CDRECURSO      VARCHAR(10);
   DECLARE @C_RECURSO_NMTPCUSTO      VARCHAR(50);
   DECLARE @C_RECURSO_CDFUNCUSTO     VARCHAR(3);
   DECLARE @C_RECURSO_QTHRREARECOP   DOUBLE PRECISION;
   DECLARE @C_RECURSO_VRCUSTO        DOUBLE PRECISION;

   DECLARE @C_RETIRADA_CDCENTCUST    VARCHAR(4);
   DECLARE @C_RETIRADA_CDPRODUTO     VARCHAR(10);
   DECLARE @C_RETIRADA_NMPRODUTO     VARCHAR(50);
   DECLARE @C_RETIRADA_CDETAPAPROD   VARCHAR(10);
   DECLARE @C_RETIRADA_QTRETI        DOUBLE PRECISION;
   DECLARE @C_RETIRADA_IDTPRETEST    VARCHAR(1);
   DECLARE @C_RETIRADA_VRCUSTPROD    DOUBLE PRECISION;

   DECLARE @C_PERDAS_CDPRODPERDA     VARCHAR(10);
   DECLARE @C_PERDAS_NMPRODUTO       VARCHAR(50);
   DECLARE @C_PERDAS_SGUNIDADE       VARCHAR(10);
   DECLARE @C_PERDAS_CDETAPAPROD     VARCHAR(10);
   DECLARE @C_PERDAS_QTPERDAOP       DOUBLE PRECISION;
   DECLARE @C_PERDAS_CDTIPOPERDA     VARCHAR(3);
   DECLARE @C_PERDAS_SGUNIDADIC      VARCHAR(10);
   DECLARE @C_PERDAS_VRCUSTPROD      DOUBLE PRECISION;
   DECLARE @C_RECURSO_CDOPERADOR     DOUBLE PRECISION;

   DECLARE @V_IDSITORDPROD           VARCHAR(1);
BEGIN
   SELECT @V_IDSITORDPROD = MAX(IDSITORDPROD)
     FROM ORDPRODUCAO
    WHERE CDFILIAL     = @P_CDFILIAL      AND
          NRORDPROD    = @P_NRORDPROD     AND
          NRSUBORDPROD = @P_NRSUBORDPROD;

   IF (@V_IDSITORDPROD <> '3') BEGIN
      SET @V_CDETAPAPROD  = NULL;
      SET @V_CDCUSTOINDI  = NULL;
      SET @V_VRFATOCONVES = 0;
      SET @V_SEQUCUSTO    = 0;

      IF @P_NRSUBLOTE IS NULL BEGIN
         SET @P_NRSUBLOTE = ' ';
      END;

      DELETE
      FROM APRCUSTOP
      WHERE CDFILIAL     = @P_CDFILIAL      AND
            NRORDPROD    = @P_NRORDPROD     AND
            NRSUBORDPROD = @P_NRSUBORDPROD;
      
      DELETE FROM APRCUSOPERA
      WHERE CDFILIAL     = @P_CDFILIAL
        AND NRORDPROD    = @P_NRORDPROD
        AND NRSUBORDPROD = @P_NRSUBORDPROD;

      SELECT
         @V_CDETAPAPROD = MIN(CDETAPAPROD)
      FROM
         ETAFABRICOP
      WHERE
         CDFILIAL     = @P_CDFILIAL AND
         NRORDPROD    = @P_NRORDPROD AND
         NRSUBORDPROD = @P_NRSUBORDPROD;

      DECLARE C_SUBPROD CURSOR FOR
         SELECT
            NRLOTEESTQ,
            NRSUBLOTE
         FROM SUBPRETAPAOP
         WHERE
            CDFILIAL     = @P_CDFILIAL  AND
            NRORDPROD    = @P_NRORDPROD AND
            NRSUBORDPROD = @P_NRSUBORDPROD;

      OPEN C_SUBPROD;
      FETCH NEXT FROM C_SUBPROD INTO @C_SUBPROD_NRLOTEESTQ, @C_SUBPROD_NRSUBLOTE;
      WHILE (@@FETCH_STATUS = 0) BEGIN

         /* S ir gerar custo para o lote da OP  */

         IF (@C_SUBPROD_NRLOTEESTQ = @P_NRLOTEESTQ) AND
            (@C_SUBPROD_NRSUBLOTE  = @P_NRSUBLOTE)  BEGIN

           /* Gera os custos para o lote principal da OP */
            DECLARE C_CUSTCALC CURSOR FOR
               SELECT
                  AUDITORIA.CDETAPAPROD,
                  AUDITORIA.NRLOTEESTQ,
                  AUDITORIA.NRSUBLOTE,
                  AUDITORIA.IDORIGAUDIT,
                  AUDITORIA.NRAUDITORIA
               FROM AUDITORIA
               WHERE AUDITORIA.CDFILIAL     = @P_CDFILIAL  AND
                     AUDITORIA.NRORDPROD    = @P_NRORDPROD AND
                     AUDITORIA.NRSUBORDPROD = @P_NRSUBORDPROD;

            OPEN C_CUSTCALC;
            FETCH NEXT FROM C_CUSTCALC INTO @C_CUSTCALC_CDETAPAPROD, @C_CUSTCALC_NRLOTEESTQ,
                                            @C_CUSTCALC_NRSUBLOTE, @C_CUSTCALC_IDORIGAUDIT,
                                            @C_CUSTCALC_NRAUDITORIA;
            WHILE (@@FETCH_STATUS = 0) BEGIN

               DECLARE C_INSPECAO CURSOR FOR
                  SELECT
                     INSPECAO.IDORIGINSPEC,
                     INSPECAO.CDINSPECAO,
                     INSPECAO.NMINSPECAO,
                     ROUND(INSPECAO.VRCUSTOINSP, 5) AS VRCUSTOINSP,
                     ISNULL(IDCOMPOECUSTO, 'N') AS IDCOMPOECUSTO,
                     INSPECAUDIT.NRAUDITORIA,
                     INSPECAUDIT.NRINSPECAUDI
                  FROM INSPECAO, INSPECAUDIT
                  WHERE INSPECAUDIT.CDFILIAL    = @P_CDFILIAL             AND
                        INSPECAUDIT.NRAUDITORIA = @C_CUSTCALC_NRAUDITORIA AND
                        INSPECAUDIT.CDINSPECAO  = INSPECAO.CDINSPECAO;

               OPEN C_INSPECAO;
               FETCH NEXT FROM C_INSPECAO INTO @C_INSPECAO_IDORIGINSPEC, @C_INSPECAO_CDINSPECAO,
                                               @C_INSPECAO_NMINSPECAO, @C_INSPECAO_VRCUSTOINSP,
                                               @C_INSPECAO_IDCOMPOECUSTO,
                                               @C_INSPECAO_NRAUDITORIA, @C_INSPECAO_NRINSPECAUDI;
               WHILE (@@FETCH_STATUS = 0) BEGIN

                 /* apurao de Custo Real da Inspeo, Anlise, Mo de Obra E Equipamentos */

                  SET @V_NMTPCUSTO = SUBSTRING(@C_INSPECAO_NMINSPECAO,1,60);

                  IF @C_INSPECAO_IDORIGINSPEC = 'QUA' BEGIN
                     SELECT @V_CDCUSTOINDI = MAX(CDCUSTOINDI)
                     FROM  CUSTOINDI
                     WHERE CDFUNCUSTO = '005';

                     IF NOT @V_CDCUSTOINDI IS NULL BEGIN

                        SET @V_SEQUCUSTO = @V_SEQUCUSTO + 1;

                        INSERT INTO APRCUSTOP
                           (CDFILIAL, NRORDPROD, NRSUBORDPROD, CDETAPAPROD, CDPRODUTO,
                            NRAPRCUSTOP, CDCUSTOINDI, CDFUNCUSTO,
                            NRLOTEESTQ, NRSUBLOTE, CDAPRCUSTOP, NMAPRCUSTOP,
                            QTAPRCUSTOP, VRAPRCUSTOP, QTHRAPRCUST)
                        VALUES
                           (@P_CDFILIAL, @P_NRORDPROD, @P_NRSUBORDPROD,  @C_CUSTCALC_CDETAPAPROD, @P_CDPRODUTO,
                            RIGHT(REPLICATE ('0',10) + @V_SEQUCUSTO,10), @V_CDCUSTOINDI, '005',
                            @C_CUSTCALC_NRLOTEESTQ, @C_CUSTCALC_NRSUBLOTE, @C_INSPECAO_CDINSPECAO,
                            @V_NMTPCUSTO, 1 , @C_INSPECAO_VRCUSTOINSP, 0);
                     END;
                  END
                  ELSE BEGIN
                     IF @C_INSPECAO_IDORIGINSPEC = 'ANA' BEGIN
                        set @C_INSPECAO_VRTOTALANA = 0;
                        SELECT @V_CDCUSTOINDI = MAX(CDCUSTOINDI)
                        FROM  CUSTOINDI
                        WHERE CDFUNCUSTO = '004';

                        if NOT @V_CDCUSTOINDI IS NULL BEGIN

                           SET @V_SEQUCUSTO = @V_SEQUCUSTO + 1;

                           IF @C_INSPECAO_IDCOMPOECUSTO = 'S' BEGIN

                              SELECT @C_INSPECAO_VRCUSTOAMOSTRA = SUM(ISNULL(VRCUSTOAMOSTRA, 0))
                              FROM FORMULAUDITANA F
                              WHERE F.CDFILIAL    = @P_CDFILIAL
                                AND F.NRAUDITORIA = @C_INSPECAO_NRAUDITORIA
                                AND F.NRLANCTOESTQ IS NOT NULL;

                              SELECT @C_INSPECAO_VRCUSTORECURSO = SUM(ISNULL(VRCUSTORECURSO, 0))
                              FROM RECURAUDITANA R
                              WHERE R.CDFILIAL    = @P_CDFILIAL
                                AND R.NRAUDITORIA = @C_INSPECAO_NRAUDITORIA;

                              SET @C_INSPECAO_VRTOTALANA = ISNULL(@C_INSPECAO_VRCUSTOAMOSTRA,0) + ISNULL(@C_INSPECAO_VRCUSTORECURSO,0);
                           END;


                           INSERT INTO APRCUSTOP
                              (CDFILIAL, NRORDPROD, NRSUBORDPROD, CDETAPAPROD, CDPRODUTO,
                               NRAPRCUSTOP, CDCUSTOINDI, CDFUNCUSTO,
                               NRLOTEESTQ, NRSUBLOTE, CDAPRCUSTOP, NMAPRCUSTOP,
                               QTAPRCUSTOP, VRAPRCUSTOP, QTHRAPRCUST)
                           VALUES
                              (@P_CDFILIAL, @P_NRORDPROD, @P_NRSUBORDPROD, @C_CUSTCALC_CDETAPAPROD, @P_CDPRODUTO,
                               RIGHT(REPLICATE ('0',10) + @V_SEQUCUSTO,10), @V_CDCUSTOINDI, '004',
                               @C_CUSTCALC_NRLOTEESTQ, @C_CUSTCALC_NRSUBLOTE, @C_INSPECAO_CDINSPECAO,
                               @V_NMTPCUSTO, 1 , @C_INSPECAO_VRTOTALANA, 0);
                        END;
                     END
                     ELSE BEGIN
                        IF @C_INSPECAO_IDORIGINSPEC = 'TAR' BEGIN
                           DECLARE C_RECURSO CURSOR FOR
                              SELECT
                                 RECURETAPAOP.CDEQUIPPRO AS CDRECURSO,
                                 EQUIPAPROD.NMEQUIPPRO AS NMTPCUSTO,
                                 '003' AS CDFUNCUSTO,
                                 ROUND(RECURETAPAOP.QTHRREARECOP, 5) AS QTHRREARECOP,
                                 ROUND(VRCUSTOEQUIP, 5) AS VRCUSTO,
                                 RECURETAPAOP.CDOPERADOR
                              FROM   RECURETAPAOP, EQUIPAPROD
                              WHERE  RECURETAPAOP.CDFILIAL      = @P_CDFILIAL              AND
                                     RECURETAPAOP.NRAUDITORIA   = @C_INSPECAO_NRAUDITORIA  AND
                                     RECURETAPAOP.NRINSPECAUDI  = @C_INSPECAO_NRINSPECAUDI AND
                                     RECURETAPAOP.IDRECURETAOP  = 'E'                      AND
                                     RECURETAPAOP.CDEQUIPPRO    = EQUIPAPROD.CDEQUIPPRO

                              UNION ALL

                              SELECT
                                 RECURETAPAOP.CDHABILIDADE AS CDRECURSO,
                                 HABILIDADE.NMHABILIDADE AS NMTPCUSTO,
                                 '002' AS CDFUNCUSTO,
                                 ROUND(RECURETAPAOP.QTHRREARECOP, 5) AS QTHRREARECOP,
                                 ROUND(ISNULL(VRCUSHRHABILOP,VRCUSHRHABIL), 5) AS VRCUSTO,
                                 RECURETAPAOP.CDOPERADOR
                              FROM   HABILIDADE, RECURETAPAOP LEFT JOIN HABILOPER
                                                              ON RECURETAPAOP.CDHABILIDADE  = HABILOPER.CDHABILIDADE AND
                                                                 RECURETAPAOP.CDOPERADOR    = HABILOPER.CDOPERADOR
                              WHERE  RECURETAPAOP.CDFILIAL      = @P_CDFILIAL              AND
                                     RECURETAPAOP.NRAUDITORIA   = @C_INSPECAO_NRAUDITORIA  AND
                                     RECURETAPAOP.NRINSPECAUDI  = @C_INSPECAO_NRINSPECAUDI AND
                                     RECURETAPAOP.IDRECURETAOP  = 'H'          AND
                                     RECURETAPAOP.CDHABILIDADE  = HABILIDADE.CDHABILIDADE;

                           OPEN C_RECURSO;
                           FETCH NEXT FROM C_RECURSO INTO @C_RECURSO_CDRECURSO, @C_RECURSO_NMTPCUSTO,
                                                          @C_RECURSO_CDFUNCUSTO, @C_RECURSO_QTHRREARECOP,
                                                          @C_RECURSO_VRCUSTO;
                           WHILE (@@FETCH_STATUS = 0) BEGIN

                              SELECT @V_CDCUSTOINDI = MAX(CDCUSTOINDI)
                              FROM  CUSTOINDI
                              WHERE CDFUNCUSTO = @C_RECURSO_CDFUNCUSTO;

                              IF NOT @V_CDCUSTOINDI IS NULL BEGIN

                                 SET @V_SEQUCUSTO = @V_SEQUCUSTO + 1;

                                 INSERT INTO APRCUSTOP
                                    (CDFILIAL, NRORDPROD, NRSUBORDPROD, CDETAPAPROD, CDPRODUTO,
                                     NRAPRCUSTOP, CDCUSTOINDI, CDFUNCUSTO,
                                     NRLOTEESTQ, NRSUBLOTE, CDAPRCUSTOP, NMAPRCUSTOP,
                                     QTAPRCUSTOP, VRAPRCUSTOP, QTHRAPRCUST)
                                 VALUES
                                    (@P_CDFILIAL, @P_NRORDPROD, @P_NRSUBORDPROD, @C_CUSTCALC_CDETAPAPROD, @P_CDPRODUTO,
                                     RIGHT(REPLICATE ('0',10) + @V_SEQUCUSTO,10), @V_CDCUSTOINDI, @C_RECURSO_CDFUNCUSTO,
                                     @C_CUSTCALC_NRLOTEESTQ, @C_CUSTCALC_NRSUBLOTE, @C_RECURSO_CDRECURSO,
                                     @C_RECURSO_NMTPCUSTO, 0 , @C_RECURSO_VRCUSTO, @C_RECURSO_QTHRREARECOP);
                              END;
                              FETCH NEXT FROM C_RECURSO INTO @C_RECURSO_CDRECURSO, @C_RECURSO_NMTPCUSTO,
                                                             @C_RECURSO_CDFUNCUSTO, @C_RECURSO_QTHRREARECOP,
                                                             @C_RECURSO_VRCUSTO;
                           END;  /* TAREFAS        */
                           CLOSE C_RECURSO;
                           DEALLOCATE C_RECURSO;
                        END;       /* IDORIG = 'TAR' */
                     END;          /* IDORIG = 'ANA' */
                  END;             /* IDORIG = 'QUA' */
                  FETCH NEXT FROM C_INSPECAO INTO @C_INSPECAO_IDORIGINSPEC, @C_INSPECAO_CDINSPECAO,
                                                  @C_INSPECAO_NMINSPECAO, @C_INSPECAO_VRCUSTOINSP,
                                                  @C_INSPECAO_NRAUDITORIA, @C_INSPECAO_NRINSPECAUDI;
               END;              /* C_INSPECAO     */
               FETCH NEXT FROM C_CUSTCALC INTO @C_CUSTCALC_CDETAPAPROD, @C_CUSTCALC_NRLOTEESTQ,
                                               @C_CUSTCALC_NRSUBLOTE, @C_CUSTCALC_IDORIGAUDIT,
                                               @C_CUSTCALC_NRAUDITORIA;

               CLOSE C_INSPECAO;
               DEALLOCATE C_INSPECAO;
            END; /* C_CUSTCALC     */
            CLOSE C_CUSTCALC;
            DEALLOCATE C_CUSTCALC;
         END
         ELSE BEGIN
            SELECT @V_CDCUSTOINDI = MAX(CDCUSTOINDI)
            FROM  CUSTOINDI
            WHERE CDFUNCUSTO = '099';

            IF (NOT @V_CDCUSTOINDI IS NULL) AND (NOT @V_CDETAPAPROD IS NULL) BEGIN

               SET @V_SEQUCUSTO = @V_SEQUCUSTO + 1;

               INSERT INTO APRCUSTOP
                  (CDFILIAL, NRORDPROD, NRSUBORDPROD, CDETAPAPROD, CDPRODUTO, NRAPRCUSTOP,
                   NRLOTEESTQ, NRSUBLOTE, CDCUSTOINDI, CDFUNCUSTO)
               VALUES
                  (@P_CDFILIAL, @P_NRORDPROD, @P_NRSUBORDPROD, @V_CDETAPAPROD, @P_CDPRODUTO,
                   RIGHT(REPLICATE ('0',10) + @V_SEQUCUSTO,10), @C_SUBPROD_NRLOTEESTQ, @C_SUBPROD_NRSUBLOTE,
                   @V_CDCUSTOINDI, '099');
            END;
         END; /* Lote da OP */
         FETCH NEXT FROM C_SUBPROD INTO @C_SUBPROD_NRLOTEESTQ, @C_SUBPROD_NRSUBLOTE;
      END;      /* C_SUBPROD*/
      CLOSE C_SUBPROD;
      DEALLOCATE C_SUBPROD;

      SELECT @V_TIPOCUSTO = MAX(NRTPCUSTOOP), @V_IDTPCALCCUSPROD = MAX(IDTPCALCCUSPROD)
      FROM
         PARAMAN
      WHERE
         CDFILIAL = @P_CDFILIAL;

      SELECT @V_CDCUSTOINDI = MAX(CDCUSTOINDI)
      FROM CUSTOINDI
      WHERE CDFUNCUSTO = '001';

      IF NOT @V_CDCUSTOINDI IS NULL BEGIN

   /* Insumos  */
         DECLARE C_RETIRADA CURSOR FOR
            SELECT CDCENTCUST, CDPRODUTO, NMPRODUTO, CDETAPAPROD,
                   QTRETI, IDTPRETEST, VRCUSTPROD
               FROM(SELECT
                        RETIRADAESTO.CDCENTCUST,
                        LOTITRETIEST.CDPRODUTO, PRODUTO.NMPRODUTO, RETIRADAESTO.CDETAPAPROD,
                        CASE ISNULL(@V_IDTPCALCCUSPROD, '1') WHEN '1' THEN ROUND(LOTITRETIEST.QTRETLIQPROD, 5) ELSE ROUND(ITEMRETIEST.QTPRERETPROD, 5) END AS QTRETI,
                        LOTITRETIEST.IDTPRETEST,
                        ROUND(TEKNISA.CUSTO_PRODUTO_LCEST(@P_CDFILIAL, ITEMRETIEST.CDPRODUTO, @V_TIPOCUSTO,
                                                          GETDATE(), GETDATE(), LOTITRETIEST.CDALMOXARIFE, LOTITRETIEST.CDLOCALESTOQ,
                                                          LOTITRETIEST.NRLOTEESTQ, LOTITRETIEST.NRSUBLOTE), 5) AS VRCUSTPROD
                      FROM
                         PRODUTO, RETIRADAESTO, ITEMRETIEST, LOTITRETIEST, PARAMAN
                      WHERE
                         RETIRADAESTO.CDFILIAL      = @P_CDFILIAL               AND
                         RETIRADAESTO.NRORDPROD     = @P_NRORDPROD              AND
                         RETIRADAESTO.NRSUBORDPROD  = @P_NRSUBORDPROD           AND
                         RETIRADAESTO.CDFILIAL      = ITEMRETIEST.CDFILIAL      AND
                         RETIRADAESTO.NRRETEST      = ITEMRETIEST.NRRETEST      AND
                         ITEMRETIEST.CDFILIAL       = LOTITRETIEST.CDFILIAL     AND
                         ITEMRETIEST.NRRETEST       = LOTITRETIEST.NRRETEST     AND
                         ITEMRETIEST.NRSEQRETPROD   = LOTITRETIEST.NRSEQRETPROD AND
                         ITEMRETIEST.CDPRODUTO      = LOTITRETIEST.CDPRODUTO    AND
                         ITEMRETIEST.CDPRODUTO      = PRODUTO.CDPRODUTO         AND
                         RETIRADAESTO.CDFILIAL      = PARAMAN.CDFILIAL          AND
                         ITEMRETIEST.CDPRODUTO NOT IN (SELECT I.CDPRODUTO
                                                            FROM ITEMPEDTERC I, ORDPRODUCAO O
                                                            WHERE O.CDFILIAL     = @P_CDFILIAL
                                                              AND O.NRORDPROD    = @P_NRORDPROD
                                                              AND O.NRSUBORDPROD = @P_NRSUBORDPROD
                                                              AND I.CDFILIAL     = O.CDFILIAL
                                                              AND I.NRPEDIDO     = O.NRPEDIDO) AND
                         (((ITEMRETIEST.CDPRODUTO <> PARAMAN.CDPRODAGUA)        OR 
                           (PARAMAN.CDPRODAGUA IS NULL))                        AND
                           ITEMRETIEST.CDPRODUTO NOT IN (SELECT CDPRODUTO
                                                           FROM MULTPRODUTOS
                                                          WHERE CDFILIAL = @P_CDFILIAL)) AND 
                         ITEMRETIEST.CDTIPORETI     NOT IN (SELECT CDTIPORETI
                                                                    FROM TIPORETI
                                                                   WHERE (CDFUNCUSTO = '099'))
                    UNION

                    SELECT
                       RETIRADAESTO.CDCENTCUST,
                       ITEMRETIEST.CDPRODUTO, PRODUTO.NMPRODUTO, RETIRADAESTO.CDETAPAPROD,
                       ROUND(ITEMRETIEST.QTPRERETPROD, 5) AS QTRETI,
                       'R' AS IDTPRETEST,
                       (((ROUND(ITEMRETIEST.QTPRERETPROD, 5) / 1000) * PM.VRPRODAGUA) / ITEMRETIEST.QTPRERETPROD) AS VRCUSTOPROD
                     FROM
                        PRODUTO, RETIRADAESTO, ITEMRETIEST, PARAMAN PM
                     WHERE
                        RETIRADAESTO.CDFILIAL      = @P_CDFILIAL                AND
                        RETIRADAESTO.NRORDPROD     = @P_NRORDPROD               AND
                        RETIRADAESTO.NRSUBORDPROD  = @P_NRSUBORDPROD            AND
                        RETIRADAESTO.CDFILIAL      = ITEMRETIEST.CDFILIAL       AND
                        RETIRADAESTO.NRRETEST      = ITEMRETIEST.NRRETEST       AND
                        ITEMRETIEST.CDPRODUTO      = PRODUTO.CDPRODUTO          AND
                        RETIRADAESTO.CDFILIAL      = PM.CDFILIAL                AND
                        ITEMRETIEST.CDPRODUTO      = PM.CDPRODAGUA              AND
                        PM.IDPRODUTOUNICO          = 'S'                        AND
                        ITEMRETIEST.CDTIPORETI     NOT IN (SELECT CDTIPORETI
                                                             FROM TIPORETI
                                                            WHERE (CDFUNCUSTO = '099'))
                    UNION

                    SELECT
                       RETIRADAESTO.CDCENTCUST,
                       ITEMRETIEST.CDPRODUTO, PRODUTO.NMPRODUTO, RETIRADAESTO.CDETAPAPROD,
                       ROUND(ITEMRETIEST.QTPRERETPROD, 5) AS QTRETI,
                       'R' AS IDTPRETEST,
                       (((ROUND(ITEMRETIEST.QTPRERETPROD, 5) / 1000) * MP1.VRPRODAGUA) / ITEMRETIEST.QTPRERETPROD) AS VRCUSTOPROD
                     FROM
                        PRODUTO, RETIRADAESTO, ITEMRETIEST, PARAMAN PM, MULTPRODUTOS MP1
                     WHERE
                        RETIRADAESTO.CDFILIAL      = @P_CDFILIAL                AND
                        RETIRADAESTO.NRORDPROD     = @P_NRORDPROD               AND
                        RETIRADAESTO.NRSUBORDPROD  = @P_NRSUBORDPROD            AND
                        RETIRADAESTO.CDFILIAL      = ITEMRETIEST.CDFILIAL       AND
                        RETIRADAESTO.NRRETEST      = ITEMRETIEST.NRRETEST       AND
                        ITEMRETIEST.CDPRODUTO      = PRODUTO.CDPRODUTO          AND
                        RETIRADAESTO.CDFILIAL      = PM.CDFILIAL                AND
                        ITEMRETIEST.CDPRODUTO      IN (SELECT CDPRODUTO
                                                         FROM MULTPRODUTOS MP2
                                                        WHERE CDFILIAL = @P_CDFILIAL
                                                          AND MP2.CDPRODUTO = MP1.CDPRODUTO
                                                          AND MP2.CDFILIAL = MP1.CDFILIAL) AND
                        PM.IDMULTPRODUTOS          = 'S'                       AND
                        RETIRADAESTO.CDFILIAL      = MP1.CDFILIAL              AND
                        ITEMRETIEST.CDTIPORETI     NOT IN (SELECT CDTIPORETI
                                                             FROM TIPORETI
                                                            WHERE (CDFUNCUSTO = '099'))

            )R;

         OPEN C_RETIRADA;
         FETCH NEXT FROM C_RETIRADA INTO @C_RETIRADA_CDCENTCUST, @C_RETIRADA_CDPRODUTO,
                                         @C_RETIRADA_NMPRODUTO, @C_RETIRADA_CDETAPAPROD,
                                         @C_RETIRADA_QTRETI, @C_RETIRADA_IDTPRETEST, @C_RETIRADA_VRCUSTPROD;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            SET @V_SEQUCUSTO = @V_SEQUCUSTO + 1;

            IF @C_RETIRADA_IDTPRETEST = 'D' BEGIN
               SET @C_RETIRADA_QTRETI = @C_RETIRADA_QTRETI * -1;
            END;

            INSERT INTO APRCUSTOP
               (CDFILIAL,
                NRORDPROD,
                NRSUBORDPROD,
                CDETAPAPROD,
                CDPRODUTO,
                NRAPRCUSTOP,
                CDCUSTOINDI,
                CDFUNCUSTO,
                NRLOTEESTQ,
                NRSUBLOTE,
                CDAPRCUSTOP,
                NMAPRCUSTOP,
                QTAPRCUSTOP,
                VRAPRCUSTOP,
                CDCENTCUST)
            VALUES
               (@P_CDFILIAL,
                @P_NRORDPROD,
                @P_NRSUBORDPROD,
                @C_RETIRADA_CDETAPAPROD,
                @P_CDPRODUTO,  /* Produto de Produo */
                RIGHT(REPLICATE ('0',10) + @V_SEQUCUSTO,10),
                @V_CDCUSTOINDI,
                '001',
                @P_NRLOTEESTQ,
                @P_NRSUBLOTE,
                @C_RETIRADA_CDPRODUTO, /* Matria Prima / Insumos */
                @C_RETIRADA_NMPRODUTO,
                @C_RETIRADA_QTRETI,
                @C_RETIRADA_VRCUSTPROD,
                @C_RETIRADA_CDCENTCUST);

            FETCH NEXT FROM C_RETIRADA INTO @C_RETIRADA_CDCENTCUST, @C_RETIRADA_CDPRODUTO,
                                            @C_RETIRADA_NMPRODUTO, @C_RETIRADA_CDETAPAPROD,
                                            @C_RETIRADA_QTRETI, @C_RETIRADA_IDTPRETEST, @C_RETIRADA_VRCUSTPROD;
         END;
         CLOSE C_RETIRADA;
         DEALLOCATE C_RETIRADA;
      END;

      SELECT @V_CDCUSTOINDI = MAX(CDCUSTOINDI)
      FROM CUSTOINDI
      WHERE CDFUNCUSTO = '099';

   /* Perdas da Produo  */

      IF NOT @V_CDCUSTOINDI IS NULL BEGIN

         DECLARE C_PERDAS CURSOR FOR
            SELECT
               P.CDPRODPERDA,
               PROD.NMPRODUTO,
               PROD.SGUNIDADE,
               P.CDETAPAPROD,
               ROUND(P.QTPERDAOP, 5) AS QTPERDAOP,
               P.CDTIPOPERDA,
               P.SGUNIDADE AS SGUNIDADIC,
               ROUND(TEKNISA.CUSTO_PRODUTO(@P_CDFILIAL, P.CDPRODPERDA, @V_TIPOCUSTO, GETDATE(), GETDATE()), 5) AS VRCUSTPROD
            FROM
               PRODUTO PROD,
               PERDAOP P
            WHERE
               P.CDFILIAL     = @P_CDFILIAL     AND
               P.NRORDPROD    = @P_NRORDPROD    AND
               P.NRSUBORDPROD = @P_NRSUBORDPROD AND
               P.CDPRODPERDA  = PROD.CDPRODUTO;

         OPEN C_PERDAS;
         FETCH NEXT FROM C_PERDAS INTO  @C_PERDAS_CDPRODPERDA, @C_PERDAS_NMPRODUTO,
                                        @C_PERDAS_SGUNIDADE, @C_PERDAS_CDETAPAPROD,
                                        @C_PERDAS_QTPERDAOP, @C_PERDAS_CDTIPOPERDA,
                                        @C_PERDAS_SGUNIDADIC, @C_PERDAS_VRCUSTPROD;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            IF NOT @C_PERDAS_SGUNIDADIC IS NULL BEGIN
               IF (@C_PERDAS_SGUNIDADIC <> @C_PERDAS_SGUNIDADE) BEGIN

                  /* Verifica o fator de conversao (caso possua unidade adicional) */

                  SELECT
                     @V_VRFATOCONVES = MIN(VRFATOCONVES)
                  FROM
                     (SELECT
                         VRFATOCONVES
                      FROM CONVPRODUTO
                      WHERE
                         (CDPRODUTO = @C_PERDAS_CDPRODPERDA) AND
                         (SGUNIDADE = @C_PERDAS_SGUNIDADIC)

                      UNION ALL

                      SELECT
                          VRFTCONVER VRFATOCONVES
                      FROM
                         CONVUNID
                      WHERE
                         (SGUNIDPARA = @C_PERDAS_SGUNIDADE)  AND
                         (SGUNIDDE   = @C_PERDAS_SGUNIDADIC) AND
                         (NOT EXISTS(SELECT
                                        SGUNIDADE
                                     FROM
                                        CONVPRODUTO
                                     WHERE
                                       (CDPRODUTO = @C_PERDAS_CDPRODPERDA) AND
                                       (SGUNIDADE = SGUNIDDE)
                                    ))
                     ) A;


                  SET @V_QTPERDAOP = @C_PERDAS_QTPERDAOP * @V_VRFATOCONVES;
               END;
            END
            ELSE BEGIN
               SET @V_QTPERDAOP = @C_PERDAS_QTPERDAOP;
            END;

            SET @V_SEQUCUSTO = @V_SEQUCUSTO + 1;

            INSERT INTO APRCUSTOP
               (CDFILIAL    ,
                NRORDPROD   ,
                NRSUBORDPROD,
                CDETAPAPROD ,
                CDPRODUTO   ,
                NRAPRCUSTOP ,
                CDCUSTOINDI ,
                CDFUNCUSTO  ,
                NRLOTEESTQ  ,
                NRSUBLOTE   ,
                CDAPRCUSTOP ,
                NMAPRCUSTOP ,
                QTAPRCUSTOP ,
                VRAPRCUSTOP ,
                CDTIPOPERDA)
            VALUES
               (@P_CDFILIAL           ,
                @P_NRORDPROD          ,
                @P_NRSUBORDPROD       ,
                @C_PERDAS_CDETAPAPROD ,
                @P_CDPRODUTO          ,
                RIGHT(REPLICATE ('0',10) + @V_SEQUCUSTO,10),
                @V_CDCUSTOINDI        ,
                '099'                ,
                @P_NRLOTEESTQ         ,
                @P_NRSUBLOTE          ,
                @C_PERDAS_CDPRODPERDA ,
                @C_PERDAS_NMPRODUTO   ,
                @V_QTPERDAOP          ,
                @C_PERDAS_VRCUSTPROD  ,
                @C_PERDAS_CDTIPOPERDA);

            FETCH NEXT FROM C_PERDAS INTO  @C_PERDAS_CDPRODPERDA, @C_PERDAS_NMPRODUTO,
                                           @C_PERDAS_SGUNIDADE, @C_PERDAS_CDETAPAPROD,
                                           @C_PERDAS_QTPERDAOP, @C_PERDAS_CDTIPOPERDA,
                                           @C_PERDAS_SGUNIDADIC, @C_PERDAS_VRCUSTPROD;
         END; /* Perda */
         CLOSE C_PERDAS;
         DEALLOCATE C_PERDAS;
      END;
   END;
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'CALCULA_CUSTO_OP','6.35.039';
GO


